#ifndef _AICommand_
#define _AICommand_
#pragma once





enum AiCommand {
	CMD_NONE,
	CMD_DEFAULT,	
	CMD_SELECT,
	CMD_POPUP,	
	CMD_STOP,
	CMD_GO,
	CMD_GO_SINGLE,
	CMD_GO_RADAR_MAP,	
	CMD_GO_DIRECTION,	
	CMD_GO_WOK,			
    
	CMD_ATTACK,							
	CMD_SPECIAL_ATTACK,					
	CMD_ANCHORED_ATTACK,				
	CMD_TRANSPORT_ATTACK,				
	CMD_FIRE_PHASER,				
	CMD_CEASE_FIRE_PHASER,			
	CMD_FIRE_PHOTON,				

	
	CMD_TACTICS,	
	CMD_ENERGY_TRIANGLE_AUTONOMY,	
	CMD_WEAPON_AUTONOMY,	

	CMD_SPEED_MODIFY,       
    CMD_ENERGY_ALLOCATION,	
	CMD_DOCK,	
	CMD_UNDOCK,	
	CMD_SILENT_MODE,	
	CMD_SCOUT,	
	CMD_PATROL,
	CMD_SEARCH_AND_DESTROY,
	CMD_GUARD,
	CMD_SHADOW,

	CMD_QUEUE,

	CMD_FORMATION,
	CMD_FORMFORMATION,
	CMD_SET_FORMATION,
	CMD_SET_FORMATION_ORIENTATION,	// Set the formation orientation to vector
	CMD_FOLLOW,	

	CMD_TRANSPORT,
	CMD_TRANSPORT_SPECIAL,
	CMD_SET_RALLY_POINT,

	CMD_CANCEL_BUILD,
	CMD_BUILD,
	CMD_DECOMMISSION,

	CMD_CANCEL_BUILD_QUEUE_ITEM,
	CMD_WORMHOLE,
	CMD_GORALLY,

	CMD_GO_WARP,			
	CMD_GO_WARP_SINGLE,
	CMD_SET_ATTACK_MODE,
	CMD_WEAPON_QUEUE,		
	CMD_UPGRADE,			
	CMD_PLANET_UPGRADE,		
	CMD_GET_SUPER_REPAIR,	
	CMD_ORBIT,				

 
	NUM_CMD
};


extern const char *AiCommandToName(AiCommand command);


extern AiCommand AiCommandFromName(const char *pName);


enum eUseType
{
	kUseType_Hail,
	kUseType_Scan,
	kUseType_Board,
	kUseType_Extra1,	//Being used for tractor beam.  NOTE: changing the name of kUseType_Extra1 will require a scriptinterface update -DANC
	kUseType_Extra2,
	kUseType_Extra3,
	kNumUseType
};

enum eOrderParameters
{
	kStraightLinePath = 1,
	kFireAtWill = 2,
	kPlayerIssuedAttack = 4,
};



extern const char* GetStringFromUseType(eUseType in_useType);
extern eUseType GetUseTypeFromString(const char *in_typeName);



#endif
