#ifndef __AttackFleet_H__
#define __AttackFleet_H__
#pragma once






#include "AIFleet.h"







class AttackFleet : public AIFleet
{
public:

	

	
	enum eAttackStage
	{
		k_ATTACK_IDLE = 0,				
		k_ATTACK_RALLY,					
		k_ATTACK_MOVE_IN,				
		k_ATTACK_ATTACK					
	};

	

	


	
	AttackFleet();


	
	virtual ~AttackFleet();

	
	virtual const AIFleetFactory* GetFactory() const;

	
	void GetDebugString
	(
		char *buffer,					
		const int maxSize				
	);




 
	
	void SetAttackStage
	(
		eAttackStage newAttackStage		
	);

	
	virtual void ProcessFleetAI(float dt);


	
	virtual bool Save(FileWriter &fp);
	virtual bool Load(FileReader &fp);


protected:

	

	

	
	eAttackStage m_AttackStage;

	

	
	float m_rallyStartTime;

	
	Vector3 m_rallyLocation;


	

	
	float m_attackTime;


	


	
	void StartAttackIdle();


	
	void AttackIdle();


	
	void ChooseRallyLocation();


	
	void SendFleetToRallyLocation();


	
	void StartAttackRally();


	
	bool RallyIsSuccessful();
	
	
	
	bool RallyTimeIsOver();

	
	void AttackRally();

	
	void StartAttackMoveIn();

	
	bool MoveInIsSuccessful();

	
	void AttackMoveIn();

	
	void StartAttackAttack();

	
	void AttackAttack();

};
//
// CLASS AttackFleet
//
///////////////////////////////////////////////////////////////////////////////


#endif 
