#ifndef __Group_h__
#define __Group_h__



typedef class character * character_ptr;
typedef class group * group_ptr;


class group 
{
private:

	linked_list	my_units;
	linked_list group_entry_functions;
	linked_list group_exit_functions;

	void add_group_rules_to_unit(character& the_unit);
	void remove_group_rules_from_unit(character& the_unit);

public:
	char *name;

	
	group(char *group_name);
	~group();


	
	void add_unit_to_group(character& the_unit);
	void remove_unit_from_group(character& the_unit);

	
	void add_group_entry_function(
		void (*GEF) (character& this_grunt),
		void (*GXF) (character& this_grunt)
		);

	void remove_group_entry_function(
		void (*GEF) (character& this_grunt),
		void (*GXF) (character& this_grunt)
		);


};

extern void add_unit_to_group(group& the_group, character& the_unit);
extern void remove_unit_from_group(group& the_group, character& the_unit);


extern group AI_Medium;


#endif // __Group_h__

