

#ifndef __IIIE_H__
#define __IIIE_H__
#pragma once

class character;
class rule;
typedef rule*	rule_ptr;

#include "linked_list.h"

class IIIE {
private:
	rule_ptr active_rule;

	
	void Fire_A_Rule
	(
		rule_ptr the_rule
	);

public:
	linked_list affected_rules_list;
	linked_list satisfied_rules_list;
	linked_list m_group_rules;			

	int character_ID;		

	IIIE();
	IIIE(int which_robot);

	~IIIE();

	void add_rule_to_affected_list(rule_ptr affected_rule);

	void evaluate();

	void trash_affected_list();

	void choose_a_satisfied_rule();

	void fire_the_current_rule();

	void fire_all_satisfied_rules();

	virtual rule_ptr create_rule(int (*left_side) (), void (*right_side) (), char *name);

	virtual rule_ptr create_rule(int (*left_side) (character&), void (*right_side) (character&), char *name);
			
	virtual void trash_rule(rule_ptr dead_rule);

	
	virtual void trash_rule(char *rule_name);
};

#endif