

#ifndef ERROR_H
#define ERROR_H


namespace LError
{
	
	void Init();
}


#ifdef LOGGING_ON
#define WARNINGS_ON
#endif


#ifndef RELEASE
#define ASSERTS_ON
#endif

#ifdef WARNINGS_ON

extern int g_noWarnErrAssertDialogs;	
extern int g_warningsEnabled;

#include "Log.h"


namespace LError
{
	
	void HandleLogError(eLogSeverity severity, const LogSource& in_LogSource, const char* in_FormatString, va_list in_argList);
};


LOGSOURCE_REFERENCE(Error);


#define ERR(x) LOGWARN(Error, kLogSeverity_Error, x)
#define WARN(x) LOGWARN(Error, kLogSeverity_Warn, x)

#else	

#define ERR(x)
#define WARN(x)

#endif	



#ifdef ASSERTS_ON


#define ASSERT(cond) do {if (!(cond)) { LOGWARN(Error, kLogSeverity_Error, (## #cond)); }} while (0)
#define ASSERTSTR(cond,x) do {if (!(cond)) { LOGWARN(Error, kLogSeverity_Error, x); } } while (0)


#define VERIFY(cond) ASSERT(cond)
#define VERIFYSTR(cond,x) ASSERTSTR(cond,x)


#define SILENTASSERT(cond) do {g_noWarnErrAssertDialogs=cond;} while(0)


#define COMPILEASSERT(cond) switch(0) {case 0:break; case (cond):break;}

#else

#define ASSERT(cond)
#define ASSERTSTR(cond,x)
#define VERIFY(cond) (cond)
#define VERIFYSTR(cond,x) (cond)
#define SILENTASSERT(cond)
#define COMPILEASSERT(cond)

#endif 




#define FATAL(x) LOGWARN(Error, kLogSeverity_Fatal, x)



#endif 


 