

#ifndef LMATH_CONSTS_H
#define LMATH_CONSTS_H





#define PI_DOUBLE			(3.14159265358979323846264)	
#define TWO_PI_DOUBLE		(2.0  * PI_DOUBLE)			
#define HALF_PI_DOUBLE		(0.5  * PI_DOUBLE)			
#define QUARTER_PI_DOUBLE	(0.25 * PI_DOUBLE)			// PI / 4, ie 45 degrees



#define PI					((float)(PI_DOUBLE))
#define TWO_PI				((float)(TWO_PI_DOUBLE))
#define HALF_PI				((float)(HALF_PI_DOUBLE))
#define QUARTER_PI			((float)(QUARTER_PI_DOUBLE))


#define DEG_TO_RAD_DOUBLE	(PI_DOUBLE / 180.0)
#define RAD_TO_DEG_DOUBLE	(180.0 / PI_DOUBLE)

#define DEG_TO_RAD			((float)DEG_TO_RAD_DOUBLE)
#define RAD_TO_DEG			((float)RAD_TO_DEG_DOUBLE)


#define SQRT2_DOUBLE		(1.41421356237309504880169)	
#define SQRT2_HALF_DOUBLE	(0.5 * SQRT2_DOUBLE)		
#define SQRT3_DOUBLE		(1.73205080756887729352745)	
#define SQRT3_HALF_DOUBLE	(0.5 * SQRT3_DOUBLE)		

// float-casts of sqrt constants
#define SQRT2				((float)(SQRT2_DOUBLE))
#define SQRT2_HALF			((float)(SQRT2_HALF_DOUBLE))
#define SQRT3				((float)(SQRT3_DOUBLE))
#define SQRT3_HALF			((float)(SQRT3_HALF_DOUBLE))



#define NAT_EXP_DOUBLE		(2.718281828459045)			
#define NAT_EXP				((float)(NAT_EXP_DOUBLE))





#define EPSILON_DOUBLE		(0.000001)					
#define EPSILON				((float)(EPSILON_DOUBLE))





#endif  
