#ifndef __MoveFleet_H__
#define __MoveFleet_H__
#pragma once






#include "AIFleet.h"







class MoveFleet : public AIFleet
{
public:

	

	
	enum eMoveStage
	{
		k_MOVE_IDLE = 0,				
		k_MOVE_FORMUP,					
		k_MOVE_TRANSIT,					
	};

	

	


	//
	// MoveFleet
	//
	// Construct an AI fleet used for laying Move
	//
	MoveFleet();


	//
	// ~MoveFleet
	//
	// Clean up an AI fleet used for laying Move
	//
	virtual ~MoveFleet();

	
	virtual const AIFleetFactory* GetFactory() const;

	
	virtual void SetFormation
	(
		int newFormation				
	);


	
	void FormFormation();


	
	void GetDebugString
	(
		char *buffer,					// Where to put the string
		const int maxSize				
	);


	
	void SetMoveStage
	(
		eMoveStage newMoveStage		// The state of Move to enter
	);

	
	virtual void ProcessFleetAI(float dt);


	
	virtual bool Save(FileWriter &fp);
	virtual bool Load(FileReader &fp);


protected:

	

	

	
	eMoveStage m_MoveStage;

	

	
	float m_transitStartTime;

	
	float m_formStart;

	


	
	void StartMoveIdle();


	
	void MoveIdle();


	
	void StartMoveFormUp();


	
	void MoveFormUp();


	
	void SendFleetToTransitLocation();


	
	void StartMoveTransit();


	
	bool TransitIsSuccessful();
	
	
	
	bool TransitTimeIsOver();

	
	void MoveTransit();


};



#endif 
