

// Make sure we only include this once.
#ifndef _A1_HOT_TYPE_H_
#define _A1_HOT_TYPE_H_


#include "linked_list.h"


typedef class rule * rule_ptr;


typedef class hot_type * hot_type_ptr;


class hot_type {

public:

	
	hot_type();

	// Function: ~hot_type
	// Author:   Brian Hawkins
	// In:
	// Out:
	// Desc:     Clean up hot_type instance.
	virtual ~hot_type();

	

	
	virtual void add_dependent_rule(rule_ptr new_rule);

	
	virtual void remove_dependent_rule(rule_ptr old_rule);

	
	virtual void construct_affected_rules_lists();

	

	
	virtual short int is_dirty();

	
	virtual void set_clean();

	
	virtual void mark_dirty();

protected:

	

	short int new_data;				// Dirty flag
	linked_list rule_dependencies;	
};

#endif 
