#pragma once
#ifndef __scripts_H__
#define __scripts_H__



#define INT_PARAM 1
#define CHARACTER_PARAM 2

#define LAST_STEP -1
#define NOT_LAST_STEP 0

typedef class script *script_ptr;

typedef class character * char_ptr;

#include "Common.h"	
#include "linked_list.h"


class script 
{
public:

	
	char m_name[MAX_STRING];

	script();

	~script();

	void add_int_param(int param_value);
	void add_character_param(char_ptr the_char);
	void *nth_param_ptr(int which_param);

	
	virtual void add_step(int (*step_fcn) (script_ptr the_script));

	
	void AddOneToReferenceCountForCurrentStep();


	
	void SubtractOneFromReferenceCountForCurrentStep();

	inline int GetStepCount(void) {
		return m_steps.count;
	}

	inline int GetCurrentStep(void) {
		return m_currentStep;
	}
	

	
	bool NoActionsPending()
	{
		
		return (m_pendingActionsCount == 0);
	}

	
	int ExecuteNextStep();

protected:

	
	linked_list m_scriptParameters;

	
	int m_currentStep;

	
	int m_pendingActionsCount;

	
	linked_list m_steps;


};
//
// CLASS: script
//
///////////////////////////////////////////////////////////////////////////////



typedef class parameter *parameter_ptr;


class parameter 
{
private:
public:
	int type;

	void *value;

};




typedef class step *step_ptr;


class step 
{
private:

public:

	int (*step_function) (script_ptr the_script);
	int pending_actions;

	void execute(script_ptr the_script);

};



void Trash_All_Action_Scripts();


void Init_All_Action_Scripts();


int Load_Action_Scripts(char *action_script_name);
void Init_Action_Scripts(int action_script_ID);
void Trash_Action_Scripts(int action_script_ID);


bool Action_Scripts_Active();

#endif
