using System;
using System.Collections.Generic;
using System.Data;
using System.Diagnostics;
using System.IO;
using System.Text;
using System.Xml;
using System.Windows.Forms;

    public class Globals
    {
        public static LocalizedStrings StringsEN;
        public static LocalizedStrings LabelsEN;
        public static string VSBinPath = "C:\\program files\\microsoft visual studio 8\\VC\\bin";

        public static string RemoveSpaces(string s)
        {
            string r = "";
            for (int i = 0; i < s.Length; i++)
            {
                if (s[i] != ' ') r += s[i];
            }
            return r;
        }

        public static void SearchReplace(string file, string search, string replace)
        {
            TextReader tr = null;
            TextWriter tw = null;
            try
            {
                tr = new StreamReader(file);
                tw = new StreamWriter("temp.txt");
                string line;
                while ((line = tr.ReadLine()) != null)
                {
                    line = line.Replace(search, replace);
                    tw.WriteLine(line);
                }
                tr.Close();
                tw.Close();
                if (File.Exists(file)) File.Delete(file);
                File.Copy("temp.txt", file);
                File.Delete("temp.txt");
            }
            catch (Exception except)
            {
                MessageBox.Show(except.ToString());
            }
            finally
            {
                if (tr != null) tr.Close();
                if (tw != null) tw.Close();
            }
        }

        public static int BinarySearch(string file, string search)
        {
            BinaryReader br = null;
            try
            {
                FileInfo finf = new FileInfo(file);
                long flen = finf.Length;
                byte[] buf = new Byte[flen];
                FileStream fin = new FileStream(file, FileMode.Open, FileAccess.Read);
                br = new BinaryReader(fin);
                br.Read(buf, 0, (int)flen);
                br.Close();
                fin = null;

                // Do the search
                int icur = 0;
                for (int i = 0; i < flen; i++)
                {
                    int j;
                    for (j = 0; j < search.Length; j++)
                    {
                        if (i + j >= flen) break;
                        if ((buf[i + j] != (byte)(search[j])) &&
                             (buf[i + j] != (byte)(search[j] - 'a' + 'A'))) break;
                    }
                    if (j == search.Length)
                    {
                        return i;
                    }
                }
            }
            catch (Exception except)
            {
                MessageBox.Show(except.ToString());
            }
            finally
            {
                if (br != null) br.Close();
            }
            return -1;
        }

        public static string BinaryToSubstring(string file, int start, int length)
        {
            BinaryReader br = null;
            try
            {
                FileInfo finf = new FileInfo(file);
                long flen = finf.Length;
                byte[] buf = new Byte[flen];
                char[] outbuf = new char[length];
                FileStream fin = new FileStream(file, FileMode.Open, FileAccess.Read);
                br = new BinaryReader(fin);
                br.Read(buf, 0, (int)flen);
                br.Close();
                fin = null;

                // Do the conversion
                int icur = 0;
                for (int i = start; i < start+length; i++)
                {
                    outbuf[icur++] = (char)buf[i];
                }
                return new String(outbuf);
            }
            catch (Exception except)
            {
                MessageBox.Show(except.ToString());
            }
            finally
            {
                if (br != null) br.Close();
            }
            return "";
        }

        public static void BinarySearchReplace(string file, string search, string replace)
        {
            BinaryReader br = null;
            BinaryWriter bw = null;
            try
            {
                FileInfo finf = new FileInfo(file);
                long flen = finf.Length;
                byte[] buf = new Byte[flen];
                byte[] outbuf = new Byte[flen * 2];
                FileStream fin = new FileStream(file, FileMode.Open, FileAccess.Read);
                br = new BinaryReader(fin);
                br.Read(buf, 0, (int)flen);
                br.Close();
                fin = null;

                // Do the search and replace
                int icur = 0;
                for (int i = 0; i < flen; i++)
                {
                    int j;
                    for (j = 0; j < search.Length; j++)
                    {
                        if (i + j >= flen) break;
                        if ((buf[i + j] != (byte)(search[j])) &&
                             (buf[i + j] != (byte)(search[j] - 'a' + 'A'))) break;
                    }
                    if (j == search.Length)
                    {
                        for (j = 0; j < replace.Length; j++)
                            outbuf[icur++] = (byte)(replace[j]);
                        i += (search.Length - 1);
                    }
                    else
                        outbuf[icur++] = buf[i];
                }

                bw = new BinaryWriter(new FileStream("sol\\temp.bin", FileMode.OpenOrCreate));
                bw.Write(outbuf, 0, icur);
                bw.Close();
                if (File.Exists(file)) File.Delete(file);
                File.Copy("sol\\temp.bin", file);
                File.Delete("sol\\temp.bin");
            }
            catch (Exception except)
            {
                MessageBox.Show(except.ToString());
            }
            finally
            {
                if (br != null) br.Close();
                if (bw != null) bw.Close();
            }
        }

        public static void ExportFile(BinaryWriter bw, BinaryReader br)
        {
            long size;
            if (br == null)
                size = 0;
            else
                size = br.BaseStream.Length;
            bw.Write(size);
            if ( br != null )
                for (int i = 0; i < br.BaseStream.Length; i++)
                    bw.Write(br.ReadByte());
        }

        public static void ExportString(BinaryWriter bw, string s)
        {
            long size = s.Length;
            bw.Write(size);
            for (int i = 0; i < s.Length; i++)
                bw.Write(s[i]);
        }
    }
