using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Data;
using System.IO;
using System.Threading;
using System.Windows.Forms;

namespace LegacyMissionEditor
{
    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            bool isNew = false;
            if( System.Diagnostics.Process.GetProcessesByName("LegacyMissionEditor").Length > 1 )
            {
                MessageBox.Show( "The Legacy Mission Editor is already running." );
                return;
            }
            if (System.Diagnostics.Process.GetProcessesByName("LegacyMissionImporter").Length > 0)
            {
                MessageBox.Show("You must close the importer before running the editor.");
                return;
            }

            Globals.StringsEN = new LocalizedStrings();
            if (Globals.StringsEN.Load("Objectives_localized_Strings_EN.xml"))
            {
                Globals.LabelsEN = new LocalizedStrings();
                if (Globals.LabelsEN.Load("LabelMap_EN.xml"))
                {
                    Missions.Load();
                    Application.EnableVisualStyles();
                    Application.SetCompatibleTextRenderingDefault(false);
                    Application.Run(new frmMissions());
                }
            }
        }
    }
}