//
// ScriptDefaultS.cpp
//
// This file contains pre-compiled scripts for the IIIE Inference Engine

// Standard includes
#include <standard.h>

// Context-dependent includes: 

// Define the constants introduced by this action script.

// GLOBALS

// New Characters

// New Groups

// New Knowledge Base Variables
#define MISSION_SUCCESS (*p_MISSION_SUCCESS)
#define MISSION_FAILURE (*p_MISSION_FAILURE)
#define WE_NEED_TO_BEGIN_MISSION (*p_WE_NEED_TO_BEGIN_MISSION)
#define MISSION_END (*p_MISSION_END)
#define tDisplayMainTitle (*p_tDisplayMainTitle)
#define tStartIntroVO (*p_tStartIntroVO)
#define tRemoveMainTitle (*p_tRemoveMainTitle)

DllExport hot_int* p_MISSION_SUCCESS;
DllExport hot_int* p_MISSION_FAILURE;
DllExport hot_int* p_WE_NEED_TO_BEGIN_MISSION;
DllExport hot_int* p_MISSION_END;
DllExport timer_int* p_tDisplayMainTitle;
DllExport timer_int* p_tStartIntroVO;
DllExport timer_int* p_tRemoveMainTitle;
DllExport Handle enterprise;
DllExport Handle Main_Title;
DllExport Handle Intro_VO_captainslog;
	
// Special instances.
#define band_selected (*p_band_selected)
#define tried_warp_team_8 (*p_tried_warp_team_8)
#define tried_warp_team_7 (*p_tried_warp_team_7)
#define tried_warp_team_6 (*p_tried_warp_team_6)
#define tried_warp_team_5 (*p_tried_warp_team_5)
#define tried_warp_team_4 (*p_tried_warp_team_4)
#define tried_warp_team_3 (*p_tried_warp_team_3)
#define tried_warp_team_2 (*p_tried_warp_team_2)
#define tried_warp_team_1 (*p_tried_warp_team_1)
#define strength_team_8 (*p_strength_team_8)
#define strength_team_7 (*p_strength_team_7)
#define strength_team_6 (*p_strength_team_6)
#define strength_team_5 (*p_strength_team_5)
#define strength_team_4 (*p_strength_team_4)
#define strength_team_3 (*p_strength_team_3)
#define strength_team_2 (*p_strength_team_2)
#define strength_team_1 (*p_strength_team_1)
#define moons_team_8 (*p_moons_team_8)
#define moons_team_7 (*p_moons_team_7)
#define moons_team_6 (*p_moons_team_6)
#define moons_team_5 (*p_moons_team_5)
#define moons_team_4 (*p_moons_team_4)
#define moons_team_3 (*p_moons_team_3)
#define moons_team_2 (*p_moons_team_2)
#define moons_team_1 (*p_moons_team_1)
#define isCineractiveDone (*p_isCineractiveDone)
#define isCineractiveCancel (*p_isCineractiveCancel)
#define ALWAYS_EVALUATE (*p_ALWAYS_EVALUATE)
#define WORLD (*p_WORLD)

DllExport hot_int* p_band_selected;
DllExport hot_int* p_tried_warp_team_8;
DllExport hot_int* p_tried_warp_team_7;
DllExport hot_int* p_tried_warp_team_6;
DllExport hot_int* p_tried_warp_team_5;
DllExport hot_int* p_tried_warp_team_4;
DllExport hot_int* p_tried_warp_team_3;
DllExport hot_int* p_tried_warp_team_2;
DllExport hot_int* p_tried_warp_team_1;
DllExport hot_float* p_strength_team_8;
DllExport hot_float* p_strength_team_7;
DllExport hot_float* p_strength_team_6;
DllExport hot_float* p_strength_team_5;
DllExport hot_float* p_strength_team_4;
DllExport hot_float* p_strength_team_3;
DllExport hot_float* p_strength_team_2;
DllExport hot_float* p_strength_team_1;
DllExport hot_int* p_moons_team_8;
DllExport hot_int* p_moons_team_7;
DllExport hot_int* p_moons_team_6;
DllExport hot_int* p_moons_team_5;
DllExport hot_int* p_moons_team_4;
DllExport hot_int* p_moons_team_3;
DllExport hot_int* p_moons_team_2;
DllExport hot_int* p_moons_team_1;
DllExport hot_int* p_isCineractiveDone;
DllExport hot_int* p_isCineractiveCancel;
DllExport dirty_int* p_ALWAYS_EVALUATE;
DllExport character* p_WORLD;


// Script Pointer that we use to talk to the game.
// This is why we need no more armada.lib.
//
DllExport ScriptInterface *g_pSI;



//*****************************************************************************
//
// ScriptDefaultS_load
//
// Load this scripts global variables.
bool ScriptDefaultS_load(FileReader &fp)
{
	// Assume status is true at start.
	bool status = true;

	// Load global variables.
	status = status && g_pSI->in(fp, &MISSION_SUCCESS);
	status = status && g_pSI->in(fp, &MISSION_FAILURE);
	status = status && g_pSI->in(fp, &WE_NEED_TO_BEGIN_MISSION);
	status = status && g_pSI->in(fp, &MISSION_END);
	status = status && g_pSI->in(fp, &tDisplayMainTitle);
	status = status && g_pSI->in(fp, &tStartIntroVO);
	status = status && g_pSI->in(fp, &tRemoveMainTitle);
	status = status && g_pSI->in(fp, &enterprise, sizeof(enterprise));
	status = status && g_pSI->in(fp, &Main_Title, sizeof(Main_Title));
	status = status && g_pSI->in(fp, &Intro_VO_captainslog, sizeof(Intro_VO_captainslog));

	// Return status.
	return(status);
}



//*****************************************************************************
//
// ScriptDefaultS_save
//
// Save this scripts global variables.
bool ScriptDefaultS_save(FileWriter &fp)
{
	// Assume status is true at start.
	bool status = true;

	// Save global variables.
	status = status && g_pSI->out(fp, &MISSION_SUCCESS, "MISSION_SUCCESS");
	status = status && g_pSI->out(fp, &MISSION_FAILURE, "MISSION_FAILURE");
	status = status && g_pSI->out(fp, &WE_NEED_TO_BEGIN_MISSION, "WE_NEED_TO_BEGIN_MISSION");
	status = status && g_pSI->out(fp, &MISSION_END, "MISSION_END");
	status = status && g_pSI->out(fp, &tDisplayMainTitle, "tDisplayMainTitle");
	status = status && g_pSI->out(fp, &tStartIntroVO, "tStartIntroVO");
	status = status && g_pSI->out(fp, &tRemoveMainTitle, "tRemoveMainTitle");
	status = status && g_pSI->out(fp, &enterprise, sizeof(enterprise), "enterprise");
	status = status && g_pSI->out(fp, &Main_Title, sizeof(Main_Title), "Main_Title");
	status = status && g_pSI->out(fp, &Intro_VO_captainslog, sizeof(Intro_VO_captainslog), "Intro_VO_captainslog");

	// Return status.
	return(status);
}



//*****************************************************************************
//
// ScriptDefaultS_script_preinit
//
// Create the script class variables for this rule set.
void ScriptDefaultS_script_preinit()
{
	 
	script_ptr the_script = NULL;
	 

	// Init file operations.
	g_pSI->AddToLoad(ScriptDefaultS_load);
	g_pSI->AddToSave(ScriptDefaultS_save);


	// Construct the pointer based variables introduced by this script.
	p_MISSION_SUCCESS = g_pSI->ScriptCreate_hot_int("MISSION_SUCCESS");
	p_MISSION_FAILURE = g_pSI->ScriptCreate_hot_int("MISSION_FAILURE");
	p_WE_NEED_TO_BEGIN_MISSION = g_pSI->ScriptCreate_hot_int("WE_NEED_TO_BEGIN_MISSION");
	p_MISSION_END = g_pSI->ScriptCreate_hot_int("MISSION_END");
	p_tDisplayMainTitle = g_pSI->ScriptCreate_timer_int("tDisplayMainTitle");
	p_tStartIntroVO = g_pSI->ScriptCreate_timer_int("tStartIntroVO");
	p_tRemoveMainTitle = g_pSI->ScriptCreate_timer_int("tRemoveMainTitle");


	// Get the special instance variables.
	p_band_selected = g_pSI->ScriptGet_band_selected();
	p_tried_warp_team_8 = g_pSI->ScriptGet_tried_warp_team_8();
	p_tried_warp_team_7 = g_pSI->ScriptGet_tried_warp_team_7();
	p_tried_warp_team_6 = g_pSI->ScriptGet_tried_warp_team_6();
	p_tried_warp_team_5 = g_pSI->ScriptGet_tried_warp_team_5();
	p_tried_warp_team_4 = g_pSI->ScriptGet_tried_warp_team_4();
	p_tried_warp_team_3 = g_pSI->ScriptGet_tried_warp_team_3();
	p_tried_warp_team_2 = g_pSI->ScriptGet_tried_warp_team_2();
	p_tried_warp_team_1 = g_pSI->ScriptGet_tried_warp_team_1();
	p_strength_team_8 = g_pSI->ScriptGet_strength_team_8();
	p_strength_team_7 = g_pSI->ScriptGet_strength_team_7();
	p_strength_team_6 = g_pSI->ScriptGet_strength_team_6();
	p_strength_team_5 = g_pSI->ScriptGet_strength_team_5();
	p_strength_team_4 = g_pSI->ScriptGet_strength_team_4();
	p_strength_team_3 = g_pSI->ScriptGet_strength_team_3();
	p_strength_team_2 = g_pSI->ScriptGet_strength_team_2();
	p_strength_team_1 = g_pSI->ScriptGet_strength_team_1();
	p_moons_team_8 = g_pSI->ScriptGet_moons_team_8();
	p_moons_team_7 = g_pSI->ScriptGet_moons_team_7();
	p_moons_team_6 = g_pSI->ScriptGet_moons_team_6();
	p_moons_team_5 = g_pSI->ScriptGet_moons_team_5();
	p_moons_team_4 = g_pSI->ScriptGet_moons_team_4();
	p_moons_team_3 = g_pSI->ScriptGet_moons_team_3();
	p_moons_team_2 = g_pSI->ScriptGet_moons_team_2();
	p_moons_team_1 = g_pSI->ScriptGet_moons_team_1();
	p_isCineractiveDone = g_pSI->ScriptGet_isCineractiveDone();
	p_isCineractiveCancel = g_pSI->ScriptGet_isCineractiveCancel();
	p_ALWAYS_EVALUATE = g_pSI->ScriptGet_ALWAYS_EVALUATE();
	p_WORLD = g_pSI->ScriptGet_WORLD();


}



//*****************************************************************************
//
// ScriptDefaultS_script_init
//
// Initialize the data for this rule set load assets.
void ScriptDefaultS_script_init()
{
	 
	script_ptr the_script = NULL;
	 
	WE_NEED_TO_BEGIN_MISSION = 1 ;
	MISSION_SUCCESS = 0 ;
	MISSION_FAILURE = 0 ;
	
}



//*****************************************************************************
//
// ScriptDefaultS_script_trash
//
// Signal that we are leaving this script & clean up.
void ScriptDefaultS_script_trash()
{
	// Trash file operations.
	g_pSI->RemoveFromLoad(ScriptDefaultS_load);
	g_pSI->RemoveFromSave(ScriptDefaultS_save);


	// Destroy the pointer based variables introduced by this script.
	g_pSI->ScriptDestroy_hot_int(p_MISSION_SUCCESS);
	g_pSI->ScriptDestroy_hot_int(p_MISSION_FAILURE);
	g_pSI->ScriptDestroy_hot_int(p_WE_NEED_TO_BEGIN_MISSION);
	g_pSI->ScriptDestroy_hot_int(p_MISSION_END);
	g_pSI->ScriptDestroy_timer_int(p_tDisplayMainTitle);
	g_pSI->ScriptDestroy_timer_int(p_tStartIntroVO);
	g_pSI->ScriptDestroy_timer_int(p_tRemoveMainTitle);

}



//*****************************************************************************
//
// ScriptDefaultS_script_entry
//
// Entry routine for the ScriptDefaultS script library



//
// ScriptDefaultS_rules_entry
//
// Entry routine for the ScriptDefaultS rules library
int WINAPI DllMain(HANDLE hModule,
	DWORD ul_reason_for_call,
	LPVOID lpReserved)
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		break;
	case DLL_PROCESS_DETACH:
		ScriptDefaultS_script_trash();
		break;
	case DLL_THREAD_ATTACH:
		break;
	case DLL_THREAD_DETACH:
		break;
	default : break;
	}
	return(TRUE);
}



//*****************************************************************************
//
// Script Extend Interface
//
// Where the game extends the script interface to the script
// and we see if our version is out of date.
 // extern "C" so we get a nice name for GetProcAddress
// We pass back the version we were built with, so the app can compare

extern "C" __declspec( dllexport ) int ScriptExtendInterface(ScriptInterface *pSI,int lastCompatibleVersion)
{
	g_pSI = pSI;
	
	// If out of date, exit immediately so we don't call bad pointers.
	if (SI_CURRENT_VERSION != lastCompatibleVersion)
		return SI_CURRENT_VERSION;

	// Create the script variables and grab the globals
	ScriptDefaultS_script_preinit();
	
	return SI_CURRENT_VERSION;
}


// VERBATIMS.
// These were blocks of raw code we just substitute script method names
// So that the calls are all made properly.




//*****************************************************************************
//
// Script Init
//
// The main init routine for the script library
// Really sets up the game
// 
// extern "C" so we get a nice name for GetProcAddress

extern "C" __declspec( dllexport ) void ScriptInit()
{
	ScriptDefaultS_script_init();
}


// ACTION_SCRIPTS.



//*****************************************************************************
// Steps for action Display_Main_Title.

// WORLD's steps


//
// WORLD_Display_Main_Title_step_1
//
// Step 1 of action "Display_Main_Title" for WORLD
int WORLD_Display_Main_Title_step_1(script_ptr the_script)
{

	return(0);
}



//
// Display_Main_Title
//
// Action script for action Display_Main_Title
DllExport void Display_Main_Title()
{
#ifdef DEBUG
	Log_Message("\n\tACTION: Display_Main_Title\n");
#endif

	 
	script_ptr the_script;
	 

	the_script = WORLD.new_script("WORLD_Display_Main_Title");

	the_script->add_step(WORLD_Display_Main_Title_step_1);

}



//*****************************************************************************
// Steps for action Remove_Main_Title.

// WORLD's steps


//
// WORLD_Remove_Main_Title_step_1
//
// Step 1 of action "Remove_Main_Title" for WORLD
int WORLD_Remove_Main_Title_step_1(script_ptr the_script)
{

	return(0);
}



//
// Remove_Main_Title
//
// Action script for action Remove_Main_Title
DllExport void Remove_Main_Title()
{
#ifdef DEBUG
	Log_Message("\n\tACTION: Remove_Main_Title\n");
#endif

	 
	script_ptr the_script;
	 

	the_script = WORLD.new_script("WORLD_Remove_Main_Title");

	the_script->add_step(WORLD_Remove_Main_Title_step_1);

}



//*****************************************************************************
// Steps for action Start_Mission.

// WORLD's steps


//
// WORLD_Start_Mission_step_1
//
// Step 1 of action "Start_Mission" for WORLD
int WORLD_Start_Mission_step_1(script_ptr the_script)
{
	g_pSI->CineractiveEnd ();
	Main_Title = g_pSI->ShowTitle ( 100 , 100 , "'Dan goes hollywood'", 0.0f , 0.5f , 1.0f , true );
	WE_NEED_TO_BEGIN_MISSION = 0 ;
	g_pSI->RestoreObjectCullingDistance ();
	g_pSI->CollisionPrevention ( true );
	g_pSI->PathPlanning ( true );
	
	return(0);
}



//
// Start_Mission
//
// Action script for action Start_Mission
DllExport void Start_Mission()
{
#ifdef DEBUG
	Log_Message("\n\tACTION: Start_Mission\n");
#endif

	 
	script_ptr the_script;
	 

	the_script = WORLD.new_script("WORLD_Start_Mission");

	the_script->add_step(WORLD_Start_Mission_step_1);

}
